"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _wrap2 = _interopRequireDefault(require("lodash/wrap"));

var _scrollBehavior = _interopRequireDefault(require("scroll-behavior"));

var _router = _interopRequireDefault(require("next/router"));

var _link = _interopRequireDefault(require("next/link"));

var _history = _interopRequireDefault(require("./history"));

var _StateStorage = _interopRequireDefault(require("./StateStorage"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* istanbul ignore next*/
if (typeof window !== 'undefined') {
  (0, _history.default)();
}

const stateStorage = new _StateStorage.default();
const scrollBehaviorSymbol = Symbol('scrollBehavior');

const getScrollBehavior = options => {
  options = {
    disableNextLinkScroll: true,
    ...options
  };

  if (_router.default[scrollBehaviorSymbol]) {
    return _router.default[scrollBehaviorSymbol];
  }

  _router.default.beforePopState = (0, _wrap2.default)(_router.default.beforePopState, (beforePopState, fn) => {
    /* istanbul ignore next*/
    fn = (0, _wrap2.default)(fn, (fn, state) => {
      location.key = state.locationKey;
      return fn(state);
    });
    return beforePopState.call(_router.default, fn);
  });

  _router.default.beforePopState(() => true);

  const scrollBehavior = new _scrollBehavior.default({
    addTransitionHook: callback => {
      _link.default.defaultProps = { ..._link.default.defaultProps,
        scroll: !options.disableNextLinkScroll
      };

      _router.default.events.on('routeChangeStart', callback);

      return () => {
        _link.default.defaultProps = { ..._link.default.defaultProps,
          scroll: true
        };

        _router.default.events.off('routeChangeStart', callback);

        delete _router.default[scrollBehaviorSymbol];
      };
    },
    getCurrentLocation: () => location,
    stateStorage
  });
  _router.default[scrollBehaviorSymbol] = scrollBehavior;
  return scrollBehavior;
};

var _default = getScrollBehavior;
exports.default = _default;
module.exports = exports.default;